/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_functionparser
#define headerfile_winix_functions_functionparser

#include "db/db.h"
#include "core/cur.h"
#include "core/system.h"


class Functions;



class FunctionParser
{
	Db        * db;
	Cur       * cur;
	System    * system;
	Functions * functions;

	GetTab::size_type get_index;
	GetTab::size_type get_tab_len;
	
	void SkipEmptyString(const char * msg);
	
	void ParseDirectories();
	void ParseItem();
	bool IsAppFunction();
	void ParseFunction();
	void ParseParams(const std::wstring & par);
	void ParseParams();

public:

	void Parse(Cur * pcur, Db * pdb, Functions * pfunctions, System * psystem);

};


#endif
