/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_upload
#define headerfile_winix_functions_upload

#include "functionbase.h"



namespace Fun
{


class Upload : public FunctionBase
{
public:

	Upload();
	bool HasAccess();
	void MakePost();
	void UploadFile(Item & item, const std::wstring & tmp_filename);

private:

	std::wstring path;
	std::string patha, path_thumba;

	bool HasAccess(const Item & item);
	bool UploadSaveStaticFile(const Item & item, const std::wstring & tmp_filename);
	bool FunUploadCheckAbuse();
	void UploadMulti();
	void UploadSingle();
	void CreateThumb(Item & item);
};


} // namespace

#endif
